void Pulse_E (void)
{
PORTD |= (1<<PD4);
_delay_us(150);						// 150s Pause, muss ans Display angepasst werden
PORTD &= ~(1<<PD4);				// 'E' Pulsen
}

void Disp_Init (void)
{
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten

PORTC = 0b00111100;								// 8 Bit / 2 Zeilen
Pulse_E();										// schreiben
PORTC = 0b00001110;								// Schreibmarke einstellen
Pulse_E();										// schreiben
PORTC = 0b00010100;								// Cursor nach rechts verschieben
Pulse_E();										// schreiben
PORTC = 0b00000001;								// Display lschen
Pulse_E();										// schreiben
PORTC = 0b00000110;								// Entry mode set
Pulse_E();										// schreiben
PORTC = 0x80;									// Zeile1, Spalte1 (0xc0 = Zeile2, Spalte1)
Pulse_E();										// schreiben

PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
}

void Disp_clr (void)
{
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten

PORTC = 0b00000001;								// Display lschen
Pulse_E();										// schreiben
PORTC = 0x80;									// Zeile1, Spalte1 + Position (1..16)
Pulse_E();										// schreiben

PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
_delay_ms(5);
}

int Disp_write_l1 (char bytel1)
{
_delay_ms(5);									// Zeichenwiederholungszeit, ans Display anpassen !!!
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten
PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = bytel1;
Pulse_E();										// schreiben

PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
return 0;
}

void Disp_write_l2 (char bytel2)
{
_delay_ms(5);									// Zeichenwiederholungszeit, ans Display anpassen !!!
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten
PORTC = 0xc0;									// Zeile2, Spalte1 + Position (1..16)
Pulse_E();										// schreiben
PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = bytel2;
Pulse_E();										// schreiben

PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
}

void cursorpos1 (char pos1)
{
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten

PORTC = 0x7f+pos1;								// Zeile1, Spalte1 + Position (1..16)
Pulse_E();										// schreiben

PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
_delay_ms(1);
}

void cursorpos2 (char pos2)
{
PORTC = 0;
DDRC = 0b11111111;								// Datenrichtung Datenbus
DDRD |= (1<<PD4) | (1<<PD5) | (1<<PD6);		// PD4=E; PD5=RW; PD6=RS
PORTD &= ~(1<<PD4) & ~(1<<PD5) & ~(1<<PD6);	// Register schreiben vorbereiten

PORTC = 0xbf+pos2;								// Zeile2, Spalte1 + Position (1..16)
Pulse_E();										// schreiben

PORTD |= (1<<PD6);								// Zeichen schreiben vorbereiten
PORTC = 0;
DDRC = 0b00000000;								// Datenbus wieder freigeben
_delay_ms(1);
}



